Description

This is a simple guide for setting up a LAMP server on Debian 7 (wheezy); which is a Linux, Apache, MySQL, and PHP web server.
When finished, web pages that are copied into the default /var/www directory will be served.

Prepare The Server

This guide is assumed that a Bare Debian install with only SSH Server access, a user that has sudo access.

e Obtain a root shell and upgrade the server:

sudo -s
apt—get update && apt—-get upgrade

e Set the hostname in the hosts:

vi /etc/hosts

o And add/modify the following:

127.0.1.1 WwWw.example.com www

e And also edit the hostname file:

vi /etc/hostname

o And add/modify the following:

WWW

® Reboot to apply the hostname settings:

reboot

Install Apache 2

¢ Install apache:

apt—-get install apache2

Configure Apache 2
e Edit the default apache2 Vhost config:

vi /etc/apache2/sites-available/default
o And add/modify the following VirtualHost block:
<VirtualHost *:80>
ServerName www.example.com
DocumentRoot /var/www
<Directory /var/www>
Options —-Indexes FollowSymLinks MultiViews
AllowOverride All
Order allow,deny
allow from all
</Directory>
</VirtualHost>

o NOTE: Make sure AllowOverride is set to ALL, or else the .htaccess file will not work.

* Restart apache2:
service apache2 restart

e Now navigate to http:/www.example.com and the default It Works! should be displayed.

Install MySQL 5.5

¢ Install MySQL server and client:

apt—-get install mysgl-server mysgl-client

o NOTE: During the setup a prompt will appear to set the root MySQL user password. Set a strong password and do not
forget it.

Configure a new MySQL database

e | og into the MySQL console:

mysgl —-h localhost -u root -p

o Create the webappuser user with the SuperSecretPassword password and the webappdb database:

CREATE USER 'webappuser'@'localhost' IDENTIFIED BY 'SuperSecretPassword';
CREATE DATABASE IF NOT EXISTS " webappdb’® CHARACTER SET utf8 COLLATE utf8_general_ci;
GRANT ALL PRIVILEGES ON “webappdb®.* TO 'webbappuser'@'localhost';

flush privileges;
exit

Install PHP 5

e |nstall PHP 5 with the apache-php module and a few common PHP extensions:

apt-get install php5 libapache2-mod-php5 php5-cli php5-mysgl phpS5-mcrypt phpb5-gd
o PHP has many extensions, run the following to get a list of all available extensions:
apt—-cache search php5-
* Restart apache for the php module to take effect:

service apache2 restart

(Extra) Install PhpMyAdmin

® [nstall phpmyadmin:

aptget install phpmyadmin
o NOTE: Make sure to enable [X]apache2 when the prompt appears.
e Open http://www.example.com/phpmyadmin to access phpmyadmin

o NOTE: The setup will not secure the phpmyadmin install, it is usually a good idea to deny access to the phpmyadmin
interface to everyone except a host or specific network like a LAN.

(Extra) Install Apache 2 Passenger

¢ Install the apache2 passenger module:
apt-get install libapache2-mod-passenger
* Edit the apache2 passenger config file:

nano /etc/apache2/mods—available/passenger.conf

o And add/modify the apache user as the default passenger user:

<IfModule mod_passenger.c>
PassengerRoot /usr
PassengerRuby /usr/bin/ruby
PassengerDefaultUser www-data
</IfModule>

e Edit the default apache2 Vhost config:

vi /etc/apache2/sites-available/default

o And add/modify the following VirtualHost block:

<VirtualHost *:80>
ServerName www.example.com

DocumentRoot /var/www/rubyapp/public
<Directory /var/www/rubyapp/public>
Options -Indexes FollowSymLinks -MultiViews
AllowOverride All
Order allow,deny
allow from all
</Directory>
</VirtualHost>

o Edit the apache?2 default ssl Vhost config file:

vi /etc/apache2/sites-available/default-ssl

o And Add the following:

<VirtualHost *:443>
ServerName www.example.com

DocumentRoot /var/www/rubyapp/public

<Directory /var/www/rubyapp/public>
Options FollowSymLinks
AllowOverride All
Require all granted

</Directory>

SSLEngine on

SSLCertificateFile /etc/apache2/ssl/www.example.com.crt
SSLCertificateKeyFile /etc/apache2/ssl/www.example.com.key

<FilesMatch "\. (cgil|shtml|phtml|php)S$">
SSLOptions +StdEnvVars

</FilesMatch>

BrowserMatch "MSIE [2-6]" nokeepalive ssl-unclean-shutdown downgrade-1.0 force-respons
e-1.0

BrowserMatch "MSIE [17-9]" ssl-unclean-shutdown
</VirtualHost>

Securing Apache with SSL

® |nstall openssl:
apt—-get install openssl
* Generate a strong SSL key and a CSR to send for signing by a CA:

mkdir /etc/apache2/ssl && cd /etc/apache2/ssl
openssl reqg -shabl2 -out www.example.com.csr —-new —-newkey rsa:4096 -nodes —-keyout www.example.
com.key

* Make sure to securely copy the SSL certificate to www.example.com.crt

* Edit the apache?2 default ssl Vhost config file:

vi /etc/apache2/sites-available/default-ssl
o And Add the following:
<VirtualHost *:443>
ServerName www.example.com

DocumentRoot /var/www
<Directory /var/www>
Options FollowSymLinks
AllowOverride All
Require all granted
</Directory>

SSLEngine on

SSLCertificateFile /etc/apache2/ssl/www.example.com.crt
SSLCertificateKeyFile /etc/apache2/ssl/www.example.com.key

<FilesMatch "\. (cgil|shtml|phtml|php)S$">
SSLOptions +StdEnvVars

</FilesMatch>

BrowserMatch "MSIE [2-6]" nokeepalive ssl-unclean-shutdown downgrade-1.0 force-respons
e-1.0

BrowserMatch "MSIE [17-9]" ssl-unclean-shutdown
</VirtualHost>

e Change the SSL certificate and key ownership to the apache user:

chown www-data:www-data /etc/apache2/ssl/www.example.com. {crt,key}
chmod o-rwx /etc/apache2/ssl/www.example.com.key

e Enable the ssl apache modules:

aZ2enmod ssl

Forcing SSL on a Website

e Enable forced SSL connection by setting the two lines from earlier in the .htaccess file. Open the file for editing:

vi /var/www/.htaccess

o Look for the following two lines, and remove the # characters before them:
RewriteCond %${HTTPS} !=on
RewriteRule ~ https://%{HTTP_HOST}%{REQUEST_URI} [L,R=301]
* Restart apache2:

service apache2 restart

* Now the website will be accessible from https:/www.example.com

Related issues:

Related to GNU/Linux Administration - Support #566: Install BeansBooks on a D... Closed 02/09/2015
Copied to GNU/Linux Administration - Support #570: Install Redmine on a Debia... Closed 02/21/2015
Copied to GNU/Linux Administration - Support #571: Install Magento on a Debia... Closed 02/21/2015
Copied to GNU/Linux Administration - Support #572: Install ownCloud on a Debi... Closed 02/21/2015
Copied to GNU/Linux Administration - Support #573: Install Piwik on a Debian ... Closed 02/21/2015
Copied to GNU/Linux Administration - Support #575: Install WordPress on a Deb... Closed 02/21/2015
History

#1 - 02/21/2015 01:39 PM - Daniel Curtis
- Target version set to Debian

#2 - 02/21/2015 01:39 PM - Daniel Curtis
- Related to Support #566: Install BeansBooks on a Debian LAMP Server added

#3 - 02/21/2015 01:50 PM - Daniel Curtis
- % Done changed from 0 to 50
- Estimated time set to 1.50 h

#5 - 02/21/2015 01:54 PM - Daniel Curtis
- Description updated

- % Done changed from 50 to 70

#6 - 02/21/2015 02:01 PM - Daniel Curtis
- Description updated

- Status changed from New to In Progress

#7 - 02/21/2015 02:03 PM - Daniel Curtis
- Description updated

#8 - 02/21/2015 02:46 PM - Daniel Curtis
- Copied to Support #570: Install Redmine on a Debian LAMP Server added

#9 - 02/21/2015 03:31 PM - Daniel Curtis
- Description updated
- Status changed from In Progress to Resolved

- % Done changed from 70 to 90

#10 - 02/22/2015 04:18 PM - Daniel Curtis

- Description updated

#11 - 02/22/2015 04:31 PM - Daniel Curtis
- Copied to Support #571: Install Magento on a Debian LAMP Server added

#12 - 02/22/2015 04:32 PM - Daniel Curtis

- Subject changed from Installing a Linux, Apache2, MySQL, PHP (LAMP) Server on Debian to Installing a Linux, Apache2, MySQL, PHP Debian
LAMP Server

#13 - 02/23/2015 09:47 AM - Daniel Curtis

- Description updated

#14 - 02/23/2015 03:41 PM - Daniel Curtis
- Copied to Support #572: Install ownCloud on a Debian LAMP Server added

#15 - 02/24/2015 01:34 PM - Daniel Curtis
- Copied to Support #573: Install Piwik on a Debian LAMP Server added

#16 - 02/25/2015 10:55 AM - Daniel Curtis
- Copied to Support #575: Install WordPress on a Debian LAMP Server added

#17 - 03/18/2015 09:39 AM - Daniel Curtis
- Status changed from Resolved to Closed

- % Done changed from 90 to 100

#18 - 10/03/2015 09:34 AM - Daniel Curtis
- Subject changed from Installing a Linux, Apache2, MySQL, PHP Debian LAMP Server to Install a Linux, Apache2, MySQL, PHP Web Server on
- Description updated
